/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 1.3.19
 * 
 * This file is not intended to be easily readable and contains a number of 
 * coding conventions designed to improve portability and efficiency. Do not make
 * changes to this file unless you know what you are doing--modify the SWIG 
 * interface file instead. 
 * ----------------------------------------------------------------------------- */


#if defined(__GNUC__)
    typedef long long __int64; /*For gcc on Windows */
#endif
#include <jni.h>
#include <stdlib.h>
#include <string.h>


/* Support for throwing Java exceptions */
typedef enum {
  SWIG_JavaOutOfMemoryError = 1, 
  SWIG_JavaIOException, 
  SWIG_JavaRuntimeException, 
  SWIG_JavaIndexOutOfBoundsException,
  SWIG_JavaArithmeticException,
  SWIG_JavaIllegalArgumentException,
  SWIG_JavaNullPointerException,
  SWIG_JavaUnknownError
} SWIG_JavaExceptionCodes;

typedef struct {
  SWIG_JavaExceptionCodes code;
  const char *java_exception;
} SWIG_JavaExceptions_t;

#if defined(SWIG_NOINCLUDE)
void SWIG_JavaThrowException(JNIEnv *jenv, SWIG_JavaExceptionCodes code, const char *msg);
#else


void SWIG_JavaThrowException(JNIEnv *jenv, SWIG_JavaExceptionCodes code, const char *msg) {
  jclass excep;
  static const SWIG_JavaExceptions_t java_exceptions[] = {
    { SWIG_JavaOutOfMemoryError, "java/lang/OutOfMemoryError" },
    { SWIG_JavaIOException, "java/io/IOException" },
    { SWIG_JavaRuntimeException, "java/lang/RuntimeException" },
    { SWIG_JavaIndexOutOfBoundsException, "java/lang/IndexOutOfBoundsException" },
    { SWIG_JavaArithmeticException, "java/lang/ArithmeticException" },
    { SWIG_JavaIllegalArgumentException, "java/lang/IllegalArgumentException" },
    { SWIG_JavaNullPointerException, "java/lang/NullPointerException" },
    { SWIG_JavaUnknownError,  "java/lang/UnknownError" },
    { (SWIG_JavaExceptionCodes)0,  "java/lang/UnknownError" } };
  const SWIG_JavaExceptions_t *except_ptr = java_exceptions;

  while (except_ptr->code != code && except_ptr->code)
    except_ptr++;

  (*jenv)->ExceptionClear(jenv);
  excep = (*jenv)->FindClass(jenv, except_ptr->java_exception);
  if (excep)
    (*jenv)->ThrowNew(jenv, excep, msg);
}


#endif



#ifdef SWIGPERL
/* for perl, these are passed in by MakeMaker derived makefile */
#undef PACKAGE
#undef VERSION

/* Delete one of many names polluted by Perl in embed.h via perl.h */
#ifdef list
#undef list
#endif
#endif

/* SWIG BUG - no SWIGTCL is defined - duh */
#ifdef TCL_MAJOR_VERSION
  /* want symbols starting librdf_ not _librdf_ */
#undef SWIG_prefix
#define SWIG_prefix
#endif

#if defined(SWIGRUBY) || defined (PHP_VERSION)
/* Ruby and PHP pollute the #define space with these names */
#undef PACKAGE_NAME
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_VERSION
#undef PACKAGE_BUGREPORT
#endif

#include <rdf_config.h>
#include <redland.h>

/* Internal prototypes */
/* FOR TESTING ERRORS ONLY - NOT PART OF API */
void librdf_internal_test_error(librdf_world *world);
void librdf_internal_test_warning(librdf_world *world);

#ifdef SWIGPYTHON
void librdf_python_world_init(librdf_world *world);
#endif
#ifdef SWIGPERL
void librdf_perl_world_init(librdf_world *world);
void librdf_perl_world_finish(void);
#endif
#ifdef SWIGPHP
librdf_world* librdf_php_get_world(void);
void librdf_php_world_finish(void);
#endif


/* 
 * Thanks to the patch in this Debian bug for the solution
 * to the crash inside vsnprintf on some architectures.
 *
 * "reuse of args inside the while(1) loop is in violation of the
 * specs and only happens to work by accident on other systems."
 *
 * http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=104325 
 */

#ifndef va_copy
#ifdef __va_copy
#define va_copy(dest,src) __va_copy(dest,src)
#else
#define va_copy(dest,src) (dest) = (src)
#endif
#endif



#ifdef SWIGPYTHON
/* swig doesn't seem to declare prototypes of get accessors for statics */
static PyObject *_wrap_librdf_copyright_string_get(void);
static PyObject *_wrap_librdf_version_string_get(void);
static PyObject *_wrap_librdf_short_copyright_string_get(void);
static PyObject *_wrap_librdf_version_decimal_get(void);

static PyObject *_wrap_librdf_version_major_get(void);
static PyObject *_wrap_librdf_version_minor_get(void);
static PyObject *_wrap_librdf_version_release_get(void);

SWIGEXPORT(void) SWIG_init(void);

static PyObject *librdf_python_callback = NULL;

static PyObject * librdf_python_set_callback(PyObject *dummy, PyObject *args);

/*
 * set the Python function object callback
 */
static PyObject *
librdf_python_set_callback(dummy, args)
  PyObject *dummy, *args;
{
  PyObject *result = NULL;
  PyObject *temp;
  
  if (PyArg_ParseTuple(args, "O:set_callback", &temp)) {
    if (!PyCallable_Check(temp)) {
      PyErr_SetString(PyExc_TypeError, "parameter must be callable");
      return NULL;
    }
    Py_XINCREF(temp);         /* Add a reference to new callback */
    Py_XDECREF(librdf_python_callback);  /* Dispose of previous callback */
    librdf_python_callback = temp;       /* Remember new callback */
    /* Boilerplate to return "None" */
    Py_INCREF(Py_None);
    result = Py_None;
  }
  return result;
}


/* Declare a table of methods that python can call */
static PyMethodDef librdf_python_methods [] = {
    {"set_callback",  librdf_python_set_callback, METH_VARARGS,
     "Set python message callback."},
    {NULL, NULL, 0, NULL}        /* Sentinel */
};


/*
 * calls a python function defined as:
 *   RDF.message($$)
 * where first argument is an integer, second is a (scalar) string
 */
static void
librdf_call_python_message(int type, const char *message, va_list arguments)
{
  char empty_buffer[1];
#ifdef PYTHON_EXCEPTIONS_WORKING
  PyObject *arglist;
  PyObject *result;
#endif
  char *buffer;
  int len;
  va_list args_copy;

  if(!librdf_python_callback) {
    fprintf(stderr, "librdf_call_python_message: No message callback registered\n");
    return;
  }

  /* ask vsnprintf size of buffer required */
  va_copy(args_copy, arguments);
  len=vsnprintf(empty_buffer, 1, message, args_copy)+1;
  va_end(args_copy);
  buffer=(char*)malloc(len);
  if(!buffer)
    fprintf(stderr, "librdf_call_python_message: Out of memory\n");
  else {
    va_copy(args_copy, arguments);
    vsnprintf(buffer, len, message, args_copy);
    va_end(args_copy);

    if(type == 0) {
#ifdef PYTHON_EXCEPTIONS_WORKING
      PyObject *error = PyErr_NewException("Redland.error", NULL, NULL);
      /* error */
      PyErr_SetString(error, buffer);
#else
      PyErr_Warn(NULL, buffer);
#endif
    } else {
      /* warning */
       PyErr_Warn(NULL, buffer);
    }

#ifdef PYTHON_EXCEPTIONS_WORKING
    /* call the callback */
    arglist = Py_BuildValue("(is)", type, buffer);
    if(!arglist) {
      fprintf(stderr, "librdf_call_python_message: Out of memory\n");
      free(buffer);
      return;
    }
    result = PyEval_CallObject(librdf_python_callback, arglist);
    Py_DECREF(arglist);
    if (result == NULL) {
      free(buffer);
      return;
    }
    
    /* no result */
    Py_DECREF(result);
#endif
    free(buffer);
  }
}

static void
librdf_python_error_handler(void *user_data, 
                            const char *message, va_list arguments)
{
  librdf_call_python_message(0, message, arguments);
}


static void
librdf_python_warning_handler(void *user_data,
                              const char *message, va_list arguments)
{
  librdf_call_python_message(1, message, arguments);
}

void
librdf_python_world_init(librdf_world *world)
{
  (void) Py_InitModule("Redland_python", librdf_python_methods);
  librdf_world_set_error(world, NULL, librdf_python_error_handler);
  librdf_world_set_warning(world,  NULL, librdf_python_warning_handler);
}
 

#endif

#ifdef SWIGPERL
/*
 * calls a perl subroutine defined as:
 *   RDF::Redland::World::message($$)
 * where first argument is an integer, second is a (scalar) string
 */
static void
librdf_call_perl_message(int type, const char *message, va_list arguments)
{
  char empty_buffer[1];
  dSP;
  char *buffer;
  int len;
  va_list args_copy;
  
  ENTER;
  SAVETMPS;

  /* ask vsnprintf size of buffer required */
  va_copy(args_copy, arguments);
  len=vsnprintf(empty_buffer, 1, message, args_copy)+1;
  va_end(args_copy);
  buffer=(char*)malloc(len);
  if(!buffer)
    fprintf(stderr, "librdf_call_perl_message: Out of memory\n");
  else {
    va_copy(args_copy, arguments);
    vsnprintf(buffer, len, message, args_copy);
    va_end(args_copy);

    PUSHMARK(SP) ;
    XPUSHs(sv_2mortal(newSViv(type)));
    XPUSHs(sv_2mortal(newSVpv(buffer, 0)));
    PUTBACK;
  
    call_pv("RDF::Redland::World::message", G_DISCARD);

    free(buffer);
  }
  
  FREETMPS;
  LEAVE;
}

static void
librdf_perl_error_handler(void *user_data, 
                          const char *message, va_list arguments)
{
  librdf_call_perl_message(0, message, arguments);
}


static void
librdf_perl_warning_handler(void *user_data,
                            const char *message, va_list arguments)
{
  librdf_call_perl_message(1, message, arguments);
}

static librdf_world* librdf_perl_world=NULL;

void
librdf_perl_world_init(librdf_world *world)
{
  librdf_world_set_error(world, NULL, librdf_perl_error_handler);
  librdf_world_set_warning(world,  NULL, librdf_perl_warning_handler);

  librdf_perl_world=world;
}

void
librdf_perl_world_finish(void)
{
  librdf_free_world(librdf_perl_world);
}
#endif


/* When in PHP when being compiled by C */
#if defined (PHP_VERSION)
static librdf_world* librdf_php_world;

static librdf_world*
librdf_php_get_world(void)
{
  return librdf_php_world;
}

void
librdf_php_world_finish(void)
{
  librdf_free_world(librdf_php_world);
}
#endif    


/* prototypes for internal routines called below - NOT PART OF API */
void librdf_error(librdf_world* world, const char *message, ...);
void librdf_warning(librdf_world* world, const char *message, ...);

/* FOR TESTING ERRORS ONLY - NOT PART OF API */
void
librdf_internal_test_error(librdf_world *world) 
{
  librdf_error(world, "test error message number %d.", 1);
}

void
librdf_internal_test_warning(librdf_world *world) 
{
  librdf_warning(world, "test warning message number %d.", 2);
}


extern char const *const librdf_short_copyright_string;
extern char const *const librdf_copyright_string;
extern char const *const librdf_version_string;
extern unsigned int const librdf_version_major;
extern unsigned int const librdf_version_minor;
extern unsigned int const librdf_version_release;
extern unsigned int const librdf_version_decimal;
#ifdef __cplusplus
extern "C" {
#endif

JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1world(JNIEnv *jenv, jclass jcls) {
    jlong jresult = 0 ;
    librdf_world *result;
    
    (void)jenv;
    (void)jcls;
    result = (librdf_world *)librdf_new_world();
    
    *(librdf_world **)&jresult = result; 
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1free_1world(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_world *arg1 = (librdf_world *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    librdf_free_world(arg1);
    
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1world_1open(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_world *arg1 = (librdf_world *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    librdf_world_open(arg1);
    
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1free_1iterator(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_iterator *arg1 = (librdf_iterator *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_iterator **)&jarg1; 
    librdf_free_iterator(arg1);
    
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1iterator_1end(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jint jresult = 0 ;
    librdf_iterator *arg1 = (librdf_iterator *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_iterator **)&jarg1; 
    result = (int)librdf_iterator_end(arg1);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1iterator_1get_1object(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_iterator *arg1 = (librdf_iterator *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_iterator **)&jarg1; 
    result = (librdf_node *)librdf_iterator_get_object(arg1);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1iterator_1get_1context(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_iterator *arg1 = (librdf_iterator *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_iterator **)&jarg1; 
    result = (librdf_node *)librdf_iterator_get_context(arg1);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1iterator_1next(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jint jresult = 0 ;
    librdf_iterator *arg1 = (librdf_iterator *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_iterator **)&jarg1; 
    result = (int)librdf_iterator_next(arg1);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1uri(JNIEnv *jenv, jclass jcls, jlong jarg1, jstring jarg2) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    char *arg2 ;
    librdf_uri *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    {
        arg2 = 0;
        if (jarg2) {
            arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
            if (!arg2) return 0;
        }
    }
    result = (librdf_uri *)librdf_new_uri(arg1,arg2);
    
    *(librdf_uri **)&jresult = result; 
    {
        if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, arg2); 
    }
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1uri_1from_1uri(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_uri *arg1 = (librdf_uri *) 0 ;
    librdf_uri *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_uri **)&jarg1; 
    result = (librdf_uri *)librdf_new_uri_from_uri(arg1);
    
    *(librdf_uri **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1uri_1from_1filename(JNIEnv *jenv, jclass jcls, jlong jarg1, jstring jarg2) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    char *arg2 ;
    librdf_uri *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    {
        arg2 = 0;
        if (jarg2) {
            arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
            if (!arg2) return 0;
        }
    }
    result = (librdf_uri *)librdf_new_uri_from_filename(arg1,(char const *)arg2);
    
    *(librdf_uri **)&jresult = result; 
    {
        if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, arg2); 
    }
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1free_1uri(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_uri *arg1 = (librdf_uri *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_uri **)&jarg1; 
    librdf_free_uri(arg1);
    
}


JNIEXPORT jstring JNICALL Java_org_librdf_redland_core_librdf_1uri_1to_1string(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jstring jresult = 0 ;
    librdf_uri *arg1 = (librdf_uri *) 0 ;
    char *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_uri **)&jarg1; 
    result = (char *)librdf_uri_to_string(arg1);
    
    {
        if(result) jresult = (*jenv)->NewStringUTF(jenv, result); 
    }
    free(result);
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1uri_1equals(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jint jresult = 0 ;
    librdf_uri *arg1 = (librdf_uri *) 0 ;
    librdf_uri *arg2 = (librdf_uri *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_uri **)&jarg1; 
    arg2 = *(librdf_uri **)&jarg2; 
    result = (int)librdf_uri_equals(arg1,arg2);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1node(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    result = (librdf_node *)librdf_new_node(arg1);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1node_1from_1uri_1string(JNIEnv *jenv, jclass jcls, jlong jarg1, jstring jarg2) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    char *arg2 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    {
        arg2 = 0;
        if (jarg2) {
            arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
            if (!arg2) return 0;
        }
    }
    result = (librdf_node *)librdf_new_node_from_uri_string(arg1,(char const *)arg2);
    
    *(librdf_node **)&jresult = result; 
    {
        if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, arg2); 
    }
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1node_1from_1uri(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    librdf_uri *arg2 = (librdf_uri *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    arg2 = *(librdf_uri **)&jarg2; 
    result = (librdf_node *)librdf_new_node_from_uri(arg1,arg2);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1node_1from_1literal(JNIEnv *jenv, jclass jcls, jlong jarg1, jstring jarg2, jstring jarg3, jint jarg4) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    char *arg2 ;
    char *arg3 ;
    int arg4 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    {
        arg2 = 0;
        if (jarg2) {
            arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
            if (!arg2) return 0;
        }
    }
    {
        arg3 = 0;
        if (jarg3) {
            arg3 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg3, 0);
            if (!arg3) return 0;
        }
    }
    arg4 = (int)jarg4; 
    result = (librdf_node *)librdf_new_node_from_literal(arg1,(char const *)arg2,(char const *)arg3,arg4);
    
    *(librdf_node **)&jresult = result; 
    {
        if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, arg2); 
    }
    {
        if (arg3) (*jenv)->ReleaseStringUTFChars(jenv, jarg3, arg3); 
    }
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1node_1from_1typed_1literal(JNIEnv *jenv, jclass jcls, jlong jarg1, jstring jarg2, jstring jarg3, jlong jarg4) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    char *arg2 ;
    char *arg3 ;
    librdf_uri *arg4 = (librdf_uri *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    {
        arg2 = 0;
        if (jarg2) {
            arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
            if (!arg2) return 0;
        }
    }
    {
        arg3 = 0;
        if (jarg3) {
            arg3 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg3, 0);
            if (!arg3) return 0;
        }
    }
    arg4 = *(librdf_uri **)&jarg4; 
    result = (librdf_node *)librdf_new_node_from_typed_literal(arg1,(char const *)arg2,(char const *)arg3,arg4);
    
    *(librdf_node **)&jresult = result; 
    {
        if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, arg2); 
    }
    {
        if (arg3) (*jenv)->ReleaseStringUTFChars(jenv, jarg3, arg3); 
    }
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1node_1from_1node(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (librdf_node *)librdf_new_node_from_node(arg1);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1node_1from_1blank_1identifier(JNIEnv *jenv, jclass jcls, jlong jarg1, jstring jarg2) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    char *arg2 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    {
        arg2 = 0;
        if (jarg2) {
            arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
            if (!arg2) return 0;
        }
    }
    result = (librdf_node *)librdf_new_node_from_blank_identifier(arg1,(char const *)arg2);
    
    *(librdf_node **)&jresult = result; 
    {
        if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, arg2); 
    }
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1free_1node(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_node *arg1 = (librdf_node *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    librdf_free_node(arg1);
    
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1node_1get_1uri(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    librdf_uri *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (librdf_uri *)librdf_node_get_uri(arg1);
    
    *(librdf_uri **)&jresult = result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1node_1get_1type(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jint jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (int)librdf_node_get_type(arg1);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jstring JNICALL Java_org_librdf_redland_core_librdf_1node_1get_1literal_1value(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jstring jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    char *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (char *)librdf_node_get_literal_value(arg1);
    
    {
        if(result) jresult = (*jenv)->NewStringUTF(jenv, result); 
    }
    return jresult;
}


JNIEXPORT jstring JNICALL Java_org_librdf_redland_core_librdf_1node_1get_1literal_1value_1as_1latin1(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jstring jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    char *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (char *)librdf_node_get_literal_value_as_latin1(arg1);
    
    {
        if(result) jresult = (*jenv)->NewStringUTF(jenv, result); 
    }
    return jresult;
}


JNIEXPORT jstring JNICALL Java_org_librdf_redland_core_librdf_1node_1get_1literal_1value_1language(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jstring jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    char *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (char *)librdf_node_get_literal_value_language(arg1);
    
    {
        if(result) jresult = (*jenv)->NewStringUTF(jenv, result); 
    }
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1node_1get_1literal_1value_1datatype_1uri(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    librdf_uri *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (librdf_uri *)librdf_node_get_literal_value_datatype_uri(arg1);
    
    *(librdf_uri **)&jresult = result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1node_1get_1literal_1value_1is_1wf_1xml(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jint jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (int)librdf_node_get_literal_value_is_wf_xml(arg1);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jstring JNICALL Java_org_librdf_redland_core_librdf_1node_1to_1string(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jstring jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    char *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (char *)librdf_node_to_string(arg1);
    
    {
        if(result) jresult = (*jenv)->NewStringUTF(jenv, result); 
    }
    free(result);
    return jresult;
}


JNIEXPORT jstring JNICALL Java_org_librdf_redland_core_librdf_1node_1get_1blank_1identifier(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jstring jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    char *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (char *)librdf_node_get_blank_identifier(arg1);
    
    {
        if(result) jresult = (*jenv)->NewStringUTF(jenv, result); 
    }
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1node_1is_1resource(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jint jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (int)librdf_node_is_resource(arg1);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1node_1is_1literal(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jint jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (int)librdf_node_is_literal(arg1);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1node_1is_1blank(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jint jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    result = (int)librdf_node_is_blank(arg1);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1node_1equals(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jint jresult = 0 ;
    librdf_node *arg1 = (librdf_node *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_node **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    result = (int)librdf_node_equals(arg1,arg2);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1statement(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    librdf_statement *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    result = (librdf_statement *)librdf_new_statement(arg1);
    
    *(librdf_statement **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1statement_1from_1statement(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_statement *arg1 = (librdf_statement *) 0 ;
    librdf_statement *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_statement **)&jarg1; 
    result = (librdf_statement *)librdf_new_statement_from_statement(arg1);
    
    *(librdf_statement **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1statement_1from_1nodes(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3, jlong jarg4) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    librdf_node *arg4 = (librdf_node *) 0 ;
    librdf_statement *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    arg4 = *(librdf_node **)&jarg4; 
    result = (librdf_statement *)librdf_new_statement_from_nodes(arg1,arg2,arg3,arg4);
    
    *(librdf_statement **)&jresult = result; 
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1free_1statement(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_statement *arg1 = (librdf_statement *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_statement **)&jarg1; 
    librdf_free_statement(arg1);
    
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1statement_1get_1subject(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_statement *arg1 = (librdf_statement *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_statement **)&jarg1; 
    result = (librdf_node *)librdf_statement_get_subject(arg1);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1statement_1set_1subject(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    librdf_statement *arg1 = (librdf_statement *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_statement **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    librdf_statement_set_subject(arg1,arg2);
    
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1statement_1get_1predicate(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_statement *arg1 = (librdf_statement *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_statement **)&jarg1; 
    result = (librdf_node *)librdf_statement_get_predicate(arg1);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1statement_1set_1predicate(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    librdf_statement *arg1 = (librdf_statement *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_statement **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    librdf_statement_set_predicate(arg1,arg2);
    
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1statement_1get_1object(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_statement *arg1 = (librdf_statement *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_statement **)&jarg1; 
    result = (librdf_node *)librdf_statement_get_object(arg1);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1statement_1set_1object(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    librdf_statement *arg1 = (librdf_statement *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_statement **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    librdf_statement_set_object(arg1,arg2);
    
}


JNIEXPORT jstring JNICALL Java_org_librdf_redland_core_librdf_1statement_1to_1string(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jstring jresult = 0 ;
    librdf_statement *arg1 = (librdf_statement *) 0 ;
    char *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_statement **)&jarg1; 
    result = (char *)librdf_statement_to_string(arg1);
    
    {
        if(result) jresult = (*jenv)->NewStringUTF(jenv, result); 
    }
    free(result);
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1model(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jstring jarg3) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    librdf_storage *arg2 = (librdf_storage *) 0 ;
    char *arg3 ;
    librdf_model *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    arg2 = *(librdf_storage **)&jarg2; 
    {
        arg3 = 0;
        if (jarg3) {
            arg3 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg3, 0);
            if (!arg3) return 0;
        }
    }
    result = (librdf_model *)librdf_new_model(arg1,arg2,arg3);
    
    *(librdf_model **)&jresult = result; 
    {
        if (arg3) (*jenv)->ReleaseStringUTFChars(jenv, jarg3, arg3); 
    }
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1model_1with_1options(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    librdf_storage *arg2 = (librdf_storage *) 0 ;
    librdf_hash *arg3 = (librdf_hash *) 0 ;
    librdf_model *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    arg2 = *(librdf_storage **)&jarg2; 
    arg3 = *(librdf_hash **)&jarg3; 
    result = (librdf_model *)librdf_new_model_with_options(arg1,arg2,arg3);
    
    *(librdf_model **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1model_1from_1model(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_model *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    result = (librdf_model *)librdf_new_model_from_model(arg1);
    
    *(librdf_model **)&jresult = result; 
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1free_1model(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_model *arg1 = (librdf_model *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    librdf_free_model(arg1);
    
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1model_1size(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jint jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    result = (int)librdf_model_size(arg1);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1model_1add(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3, jlong jarg4) {
    jint jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    librdf_node *arg4 = (librdf_node *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    arg4 = *(librdf_node **)&jarg4; 
    result = (int)librdf_model_add(arg1,arg2,arg3,arg4);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1model_1add_1typed_1literal_1statement(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3, jstring jarg4, jstring jarg5, jlong jarg6) {
    jint jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    char *arg4 ;
    char *arg5 ;
    librdf_uri *arg6 = (librdf_uri *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    {
        arg4 = 0;
        if (jarg4) {
            arg4 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg4, 0);
            if (!arg4) return 0;
        }
    }
    {
        arg5 = 0;
        if (jarg5) {
            arg5 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg5, 0);
            if (!arg5) return 0;
        }
    }
    arg6 = *(librdf_uri **)&jarg6; 
    result = (int)librdf_model_add_typed_literal_statement(arg1,arg2,arg3,arg4,arg5,arg6);
    
    jresult = (jint)result; 
    {
        if (arg4) (*jenv)->ReleaseStringUTFChars(jenv, jarg4, arg4); 
    }
    {
        if (arg5) (*jenv)->ReleaseStringUTFChars(jenv, jarg5, arg5); 
    }
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1model_1add_1statement(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jint jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_statement *arg2 = (librdf_statement *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_statement **)&jarg2; 
    result = (int)librdf_model_add_statement(arg1,arg2);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1model_1add_1statements(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jint jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_stream *arg2 = (librdf_stream *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_stream **)&jarg2; 
    result = (int)librdf_model_add_statements(arg1,arg2);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1model_1remove_1statement(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jint jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_statement *arg2 = (librdf_statement *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_statement **)&jarg2; 
    result = (int)librdf_model_remove_statement(arg1,arg2);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1model_1contains_1statement(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jint jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_statement *arg2 = (librdf_statement *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_statement **)&jarg2; 
    result = (int)librdf_model_contains_statement(arg1,arg2);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1model_1as_1stream(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_stream *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    result = (librdf_stream *)librdf_model_as_stream(arg1);
    
    *(librdf_stream **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1model_1find_1statements(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_statement *arg2 = (librdf_statement *) 0 ;
    librdf_stream *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_statement **)&jarg2; 
    result = (librdf_stream *)librdf_model_find_statements(arg1,arg2);
    
    *(librdf_stream **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1model_1find_1statements_1in_1context(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_statement *arg2 = (librdf_statement *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    librdf_stream *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_statement **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    result = (librdf_stream *)librdf_model_find_statements_in_context(arg1,arg2,arg3);
    
    *(librdf_stream **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1model_1get_1sources(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    librdf_iterator *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    result = (librdf_iterator *)librdf_model_get_sources(arg1,arg2,arg3);
    
    *(librdf_iterator **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1model_1get_1arcs(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    librdf_iterator *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    result = (librdf_iterator *)librdf_model_get_arcs(arg1,arg2,arg3);
    
    *(librdf_iterator **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1model_1get_1targets(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    librdf_iterator *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    result = (librdf_iterator *)librdf_model_get_targets(arg1,arg2,arg3);
    
    *(librdf_iterator **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1model_1get_1source(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    result = (librdf_node *)librdf_model_get_source(arg1,arg2,arg3);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1model_1get_1arc(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    result = (librdf_node *)librdf_model_get_arc(arg1,arg2,arg3);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1model_1get_1target(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    result = (librdf_node *)librdf_model_get_target(arg1,arg2,arg3);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1model_1context_1add_1statement(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jint jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_statement *arg3 = (librdf_statement *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    arg3 = *(librdf_statement **)&jarg3; 
    result = (int)librdf_model_context_add_statement(arg1,arg2,arg3);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1model_1context_1add_1statements(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jint jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_stream *arg3 = (librdf_stream *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    arg3 = *(librdf_stream **)&jarg3; 
    result = (int)librdf_model_context_add_statements(arg1,arg2,arg3);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1model_1context_1remove_1statement(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jint jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_statement *arg3 = (librdf_statement *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    arg3 = *(librdf_statement **)&jarg3; 
    result = (int)librdf_model_context_remove_statement(arg1,arg2,arg3);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1model_1context_1remove_1statements(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jint jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    result = (int)librdf_model_context_remove_statements(arg1,arg2);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1model_1context_1as_1stream(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_node *arg2 = (librdf_node *) 0 ;
    librdf_stream *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_node **)&jarg2; 
    result = (librdf_stream *)librdf_model_context_as_stream(arg1,arg2);
    
    *(librdf_stream **)&jresult = result; 
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1model_1sync(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_model *arg1 = (librdf_model *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    librdf_model_sync(arg1);
    
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1model_1get_1contexts(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_iterator *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    result = (librdf_iterator *)librdf_model_get_contexts(arg1);
    
    *(librdf_iterator **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1model_1get_1feature(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jlong jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_uri *arg2 = (librdf_uri *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_uri **)&jarg2; 
    result = (librdf_node *)librdf_model_get_feature(arg1,arg2);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1model_1set_1feature(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jint jresult = 0 ;
    librdf_model *arg1 = (librdf_model *) 0 ;
    librdf_uri *arg2 = (librdf_uri *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_model **)&jarg1; 
    arg2 = *(librdf_uri **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    result = (int)librdf_model_set_feature(arg1,arg2,arg3);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1storage(JNIEnv *jenv, jclass jcls, jlong jarg1, jstring jarg2, jstring jarg3, jstring jarg4) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    char *arg2 ;
    char *arg3 ;
    char *arg4 ;
    librdf_storage *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    {
        arg2 = 0;
        if (jarg2) {
            arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
            if (!arg2) return 0;
        }
    }
    {
        arg3 = 0;
        if (jarg3) {
            arg3 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg3, 0);
            if (!arg3) return 0;
        }
    }
    {
        arg4 = 0;
        if (jarg4) {
            arg4 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg4, 0);
            if (!arg4) return 0;
        }
    }
    result = (librdf_storage *)librdf_new_storage(arg1,arg2,arg3,arg4);
    
    *(librdf_storage **)&jresult = result; 
    {
        if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, arg2); 
    }
    {
        if (arg3) (*jenv)->ReleaseStringUTFChars(jenv, jarg3, arg3); 
    }
    {
        if (arg4) (*jenv)->ReleaseStringUTFChars(jenv, jarg4, arg4); 
    }
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1storage_1from_1storage(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_storage *arg1 = (librdf_storage *) 0 ;
    librdf_storage *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_storage **)&jarg1; 
    result = (librdf_storage *)librdf_new_storage_from_storage(arg1);
    
    *(librdf_storage **)&jresult = result; 
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1free_1storage(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_storage *arg1 = (librdf_storage *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_storage **)&jarg1; 
    librdf_free_storage(arg1);
    
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1parser(JNIEnv *jenv, jclass jcls, jlong jarg1, jstring jarg2, jstring jarg3, jlong jarg4) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    char *arg2 ;
    char *arg3 ;
    librdf_uri *arg4 = (librdf_uri *) 0 ;
    librdf_parser *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    {
        arg2 = 0;
        if (jarg2) {
            arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
            if (!arg2) return 0;
        }
    }
    {
        arg3 = 0;
        if (jarg3) {
            arg3 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg3, 0);
            if (!arg3) return 0;
        }
    }
    arg4 = *(librdf_uri **)&jarg4; 
    result = (librdf_parser *)librdf_new_parser(arg1,(char const *)arg2,(char const *)arg3,arg4);
    
    *(librdf_parser **)&jresult = result; 
    {
        if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, arg2); 
    }
    {
        if (arg3) (*jenv)->ReleaseStringUTFChars(jenv, jarg3, arg3); 
    }
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1free_1parser(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_parser *arg1 = (librdf_parser *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_parser **)&jarg1; 
    librdf_free_parser(arg1);
    
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1parser_1parse_1as_1stream(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jlong jresult = 0 ;
    librdf_parser *arg1 = (librdf_parser *) 0 ;
    librdf_uri *arg2 = (librdf_uri *) 0 ;
    librdf_uri *arg3 = (librdf_uri *) 0 ;
    librdf_stream *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_parser **)&jarg1; 
    arg2 = *(librdf_uri **)&jarg2; 
    arg3 = *(librdf_uri **)&jarg3; 
    result = (librdf_stream *)librdf_parser_parse_as_stream(arg1,arg2,arg3);
    
    *(librdf_stream **)&jresult = result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1parser_1parse_1into_1model(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3, jlong jarg4) {
    jint jresult = 0 ;
    librdf_parser *arg1 = (librdf_parser *) 0 ;
    librdf_uri *arg2 = (librdf_uri *) 0 ;
    librdf_uri *arg3 = (librdf_uri *) 0 ;
    librdf_model *arg4 = (librdf_model *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_parser **)&jarg1; 
    arg2 = *(librdf_uri **)&jarg2; 
    arg3 = *(librdf_uri **)&jarg3; 
    arg4 = *(librdf_model **)&jarg4; 
    result = (int)librdf_parser_parse_into_model(arg1,arg2,arg3,arg4);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1parser_1parse_1string_1as_1stream(JNIEnv *jenv, jclass jcls, jlong jarg1, jstring jarg2, jlong jarg3) {
    jlong jresult = 0 ;
    librdf_parser *arg1 = (librdf_parser *) 0 ;
    char *arg2 ;
    librdf_uri *arg3 = (librdf_uri *) 0 ;
    librdf_stream *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_parser **)&jarg1; 
    {
        arg2 = 0;
        if (jarg2) {
            arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
            if (!arg2) return 0;
        }
    }
    arg3 = *(librdf_uri **)&jarg3; 
    result = (librdf_stream *)librdf_parser_parse_string_as_stream(arg1,(char const *)arg2,arg3);
    
    *(librdf_stream **)&jresult = result; 
    {
        if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, arg2); 
    }
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1parser_1parse_1string_1into_1model(JNIEnv *jenv, jclass jcls, jlong jarg1, jstring jarg2, jlong jarg3, jlong jarg4) {
    jint jresult = 0 ;
    librdf_parser *arg1 = (librdf_parser *) 0 ;
    char *arg2 ;
    librdf_uri *arg3 = (librdf_uri *) 0 ;
    librdf_model *arg4 = (librdf_model *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_parser **)&jarg1; 
    {
        arg2 = 0;
        if (jarg2) {
            arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
            if (!arg2) return 0;
        }
    }
    arg3 = *(librdf_uri **)&jarg3; 
    arg4 = *(librdf_model **)&jarg4; 
    result = (int)librdf_parser_parse_string_into_model(arg1,(char const *)arg2,arg3,arg4);
    
    jresult = (jint)result; 
    {
        if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, arg2); 
    }
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1parser_1get_1feature(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jlong jresult = 0 ;
    librdf_parser *arg1 = (librdf_parser *) 0 ;
    librdf_uri *arg2 = (librdf_uri *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_parser **)&jarg1; 
    arg2 = *(librdf_uri **)&jarg2; 
    result = (librdf_node *)librdf_parser_get_feature(arg1,arg2);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1parser_1set_1feature(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jint jresult = 0 ;
    librdf_parser *arg1 = (librdf_parser *) 0 ;
    librdf_uri *arg2 = (librdf_uri *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_parser **)&jarg1; 
    arg2 = *(librdf_uri **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    result = (int)librdf_parser_set_feature(arg1,arg2,arg3);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1new_1serializer(JNIEnv *jenv, jclass jcls, jlong jarg1, jstring jarg2, jstring jarg3, jlong jarg4) {
    jlong jresult = 0 ;
    librdf_world *arg1 = (librdf_world *) 0 ;
    char *arg2 ;
    char *arg3 ;
    librdf_uri *arg4 = (librdf_uri *) 0 ;
    librdf_serializer *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    {
        arg2 = 0;
        if (jarg2) {
            arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
            if (!arg2) return 0;
        }
    }
    {
        arg3 = 0;
        if (jarg3) {
            arg3 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg3, 0);
            if (!arg3) return 0;
        }
    }
    arg4 = *(librdf_uri **)&jarg4; 
    result = (librdf_serializer *)librdf_new_serializer(arg1,(char const *)arg2,(char const *)arg3,arg4);
    
    *(librdf_serializer **)&jresult = result; 
    {
        if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, arg2); 
    }
    {
        if (arg3) (*jenv)->ReleaseStringUTFChars(jenv, jarg3, arg3); 
    }
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1free_1serializer(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_serializer *arg1 = (librdf_serializer *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_serializer **)&jarg1; 
    librdf_free_serializer(arg1);
    
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1serializer_1serialize_1model_1to_1file(JNIEnv *jenv, jclass jcls, jlong jarg1, jstring jarg2, jlong jarg3, jlong jarg4) {
    jint jresult = 0 ;
    librdf_serializer *arg1 = (librdf_serializer *) 0 ;
    char *arg2 ;
    librdf_uri *arg3 = (librdf_uri *) 0 ;
    librdf_model *arg4 = (librdf_model *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_serializer **)&jarg1; 
    {
        arg2 = 0;
        if (jarg2) {
            arg2 = (char *)(*jenv)->GetStringUTFChars(jenv, jarg2, 0);
            if (!arg2) return 0;
        }
    }
    arg3 = *(librdf_uri **)&jarg3; 
    arg4 = *(librdf_model **)&jarg4; 
    result = (int)librdf_serializer_serialize_model_to_file(arg1,(char const *)arg2,arg3,arg4);
    
    jresult = (jint)result; 
    {
        if (arg2) (*jenv)->ReleaseStringUTFChars(jenv, jarg2, arg2); 
    }
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1serializer_1get_1feature(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2) {
    jlong jresult = 0 ;
    librdf_serializer *arg1 = (librdf_serializer *) 0 ;
    librdf_uri *arg2 = (librdf_uri *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_serializer **)&jarg1; 
    arg2 = *(librdf_uri **)&jarg2; 
    result = (librdf_node *)librdf_serializer_get_feature(arg1,arg2);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1serializer_1set_1feature(JNIEnv *jenv, jclass jcls, jlong jarg1, jlong jarg2, jlong jarg3) {
    jint jresult = 0 ;
    librdf_serializer *arg1 = (librdf_serializer *) 0 ;
    librdf_uri *arg2 = (librdf_uri *) 0 ;
    librdf_node *arg3 = (librdf_node *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_serializer **)&jarg1; 
    arg2 = *(librdf_uri **)&jarg2; 
    arg3 = *(librdf_node **)&jarg3; 
    result = (int)librdf_serializer_set_feature(arg1,arg2,arg3);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1free_1stream(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_stream *arg1 = (librdf_stream *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_stream **)&jarg1; 
    librdf_free_stream(arg1);
    
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1stream_1end(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jint jresult = 0 ;
    librdf_stream *arg1 = (librdf_stream *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_stream **)&jarg1; 
    result = (int)librdf_stream_end(arg1);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jint JNICALL Java_org_librdf_redland_core_librdf_1stream_1next(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jint jresult = 0 ;
    librdf_stream *arg1 = (librdf_stream *) 0 ;
    int result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_stream **)&jarg1; 
    result = (int)librdf_stream_next(arg1);
    
    jresult = (jint)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1stream_1get_1object(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_stream *arg1 = (librdf_stream *) 0 ;
    librdf_statement *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_stream **)&jarg1; 
    result = (librdf_statement *)librdf_stream_get_object(arg1);
    
    *(librdf_statement **)&jresult = result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_librdf_1stream_1get_1context(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    jlong jresult = 0 ;
    librdf_stream *arg1 = (librdf_stream *) 0 ;
    librdf_node *result;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_stream **)&jarg1; 
    result = (librdf_node *)librdf_stream_get_context(arg1);
    
    *(librdf_node **)&jresult = result; 
    return jresult;
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1internal_1test_1error(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_world *arg1 = (librdf_world *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    librdf_internal_test_error(arg1);
    
}


JNIEXPORT void JNICALL Java_org_librdf_redland_core_librdf_1internal_1test_1warning(JNIEnv *jenv, jclass jcls, jlong jarg1) {
    librdf_world *arg1 = (librdf_world *) 0 ;
    
    (void)jenv;
    (void)jcls;
    arg1 = *(librdf_world **)&jarg1; 
    librdf_internal_test_warning(arg1);
    
}


JNIEXPORT jstring JNICALL Java_org_librdf_redland_core_get_1librdf_1short_1copyright_1string(JNIEnv *jenv, jclass jcls) {
    jstring jresult = 0 ;
    char *result;
    
    (void)jenv;
    (void)jcls;
    result = (char *)(char *)librdf_short_copyright_string;
    
    {
        if(result) jresult = (*jenv)->NewStringUTF(jenv, result); 
    }
    return jresult;
}


JNIEXPORT jstring JNICALL Java_org_librdf_redland_core_get_1librdf_1copyright_1string(JNIEnv *jenv, jclass jcls) {
    jstring jresult = 0 ;
    char *result;
    
    (void)jenv;
    (void)jcls;
    result = (char *)(char *)librdf_copyright_string;
    
    {
        if(result) jresult = (*jenv)->NewStringUTF(jenv, result); 
    }
    return jresult;
}


JNIEXPORT jstring JNICALL Java_org_librdf_redland_core_get_1librdf_1version_1string(JNIEnv *jenv, jclass jcls) {
    jstring jresult = 0 ;
    char *result;
    
    (void)jenv;
    (void)jcls;
    result = (char *)(char *)librdf_version_string;
    
    {
        if(result) jresult = (*jenv)->NewStringUTF(jenv, result); 
    }
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_get_1librdf_1version_1major(JNIEnv *jenv, jclass jcls) {
    jlong jresult = 0 ;
    unsigned int result;
    
    (void)jenv;
    (void)jcls;
    result = (unsigned int)(unsigned int)librdf_version_major;
    
    jresult = (jlong)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_get_1librdf_1version_1minor(JNIEnv *jenv, jclass jcls) {
    jlong jresult = 0 ;
    unsigned int result;
    
    (void)jenv;
    (void)jcls;
    result = (unsigned int)(unsigned int)librdf_version_minor;
    
    jresult = (jlong)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_get_1librdf_1version_1release(JNIEnv *jenv, jclass jcls) {
    jlong jresult = 0 ;
    unsigned int result;
    
    (void)jenv;
    (void)jcls;
    result = (unsigned int)(unsigned int)librdf_version_release;
    
    jresult = (jlong)result; 
    return jresult;
}


JNIEXPORT jlong JNICALL Java_org_librdf_redland_core_get_1librdf_1version_1decimal(JNIEnv *jenv, jclass jcls) {
    jlong jresult = 0 ;
    unsigned int result;
    
    (void)jenv;
    (void)jcls;
    result = (unsigned int)(unsigned int)librdf_version_decimal;
    
    jresult = (jlong)result; 
    return jresult;
}


#ifdef __cplusplus
}
#endif

#ifdef TCL_MAJOR_VERSION
Tcl_PkgProvide(interp, PACKAGE, (char*)librdf_version_string);
#endif

#ifdef PHP_VERSION
/* PHP seems happier if this happens at module init time */
if(!librdf_php_world) {
    librdf_php_world=librdf_new_world();
    librdf_world_open(librdf_php_world);
}
#endif


